dnl -*- mode: Autoconf -*- 
dnl
dnl AC_ROOT_SMI([MINIMUM-VERSION 
dnl                   [,ACTION-IF_FOUND 
dnl                    [, ACTION-IF-NOT-FOUND]])
AC_DEFUN([AC_ROOT_SMIXX],
[
    AC_ARG_WITH([smixx-prefix],
        [AC_HELP_STRING([--with-smixx-prefix],
		[Prefix where Smixx is installed])],
        smixx_prefix=$withval, smixx_prefix="")

    if test "x${SMIXX_CONFIG+set}" != xset ; then 
        if test "x$smixx_prefix" != "x" ; then 
	    SMIXX_CONFIG=$smixx_prefix/bin/smixx-config
	fi
    fi   
    if test "x${SMIXX_CONFIG+set}" != xset ; then 
        if test "x$smixx_prefix" != "x" ; then 
	    SMIXX_CONFIG=$smixx_prefix/bin/smixx-config
	fi
    fi   
    AC_PATH_PROG(SMIXX_CONFIG, smixx-config, no)
    smixx_min_version=ifelse([$1], ,0.1,$1)
    
    AC_MSG_CHECKING(for Smixx version >= $smixx_min_version)

    smixx_found=no    
    if test "x$SMIXX_CONFIG" != "xno" ; then 
       SMIXX_CPPFLAGS=`$SMIXX_CONFIG --cppflags`
       SMIXX_INCLUDEDIR=`$SMIXX_CONFIG --includedir`
       SMIXX_LIBS=`$SMIXX_CONFIG --libs`
       SMIXX_LIBDIR=`$SMIXX_CONFIG --libdir`
       SMIXX_LDFLAGS=`$SMIXX_CONFIG --ldflags`
       SMIXX_PREFIX=`$SMIXX_CONFIG --prefix`
       
       smixx_version=`$SMIXX_CONFIG -V` 
       smixx_vers=`echo $smixx_version | \
         awk 'BEGIN { FS = " "; } \
	   { printf "%d", ($''1 * 1000 + $''2) * 1000 + $''3;}'`
       smixx_regu=`echo $smixx_min_version | \
         awk 'BEGIN { FS = " "; } \
	   { printf "%d", ($''1 * 1000 + $''2) * 1000 + $''3;}'`
       if test $smixx_vers -ge $smixx_regu ; then 
            smixx_found=yes
       fi
    fi
    AC_MSG_RESULT($smixx_found - is $smixx_version) 
  
    if test "x$smixx_found" = "xyes" ; then 
        ifelse([$2], , :, [$2])
    else 
        ifelse([$3], , :, [$3])
    fi
    AC_SUBST(SMIXX_PREFIX)
    AC_SUBST(SMIXX_CPPFLAGS)
    AC_SUBST(SMIXX_INCLUDEDIR)
    AC_SUBST(SMIXX_LDFLAGS)
    AC_SUBST(SMIXX_LIBDIR)
    AC_SUBST(SMIXX_LIBS)
])

dnl
dnl EOF
dnl 
